MODULE MAP_Steel_Acquire_Data

INTERFACE reed
  MODULE PROCEDURE MAP_UTIL_REED,MAP_UTIL_REEDI
END INTERFACE 

PRIVATE
PUBLIC :: LOGO,MAP_UTIL_REED,MAP_UTIL_REEDI,REED_IN_KEYS,&
          REED_IN_FILE,INPUT_TYPE

CONTAINS

! -----------------------------------------------------------------------
!
! Subroutine LOGO
!
! -----------------------------------------------------------------------
  SUBROUTINE LOGO()
      WRITE(6,432)
      WRITE(6,1)
      WRITE(6,2)
      WRITE(6,2)
      WRITE(6,6)
      WRITE(6,2)
      WRITE(6,2)
300   WRITE(6,2)
      WRITE(6,8)
      WRITE(6,2)
      WRITE(6,9)
      WRITE(6,10)
      WRITE(6,2)
      WRITE(6,2)
      WRITE(6,1)
      WRITE(6,433)
432   FORMAT(//////////)
1     FORMAT(&
     &10X,' *************************************************',&
     &'**********')
2     FORMAT(10X,' **',55X,'**')
6     FORMAT(10X,' **',14X,'  TTT DIAGRAMS FOR STEELS ',15X,'**')
8     FORMAT(10X,' **',8X,'                  by                  ',&
     &9X,'**')
9     FORMAT(10X,' **',8X,'         H. K. D. H. Bhadeshia        ',&
     &9X,'**')
10    FORMAT(10X,' **',8X,'        University of Cambridge       ',&
     &9X,'**')
433   FORMAT(////)
    RETURN
  END SUBROUTINE LOGO
! -----------------------------------------------------------------------
!
! Subroutine BOUND
!
! -----------------------------------------------------------------------
      SUBROUTINE BOUND(A,B,C)
       USE MAP_Util_Global_Data
       IMPLICIT NONE
       REAL(KIND=real_8_30), INTENT(INOUT) :: A
       REAL(KIND=real_8_30), INTENT(IN)    :: B,C

         DO
            IF (A .LT. B .OR. A .GT. C) THEN
               WRITE(11,1) B,C
               CALL reed(A)
            ELSE
               EXIT
            END  IF
         END DO

       RETURN
1      FORMAT(12X,' Input value out of bounds'/ &
     &   14X,' The limits are ',D12.4,' to ', D12.4/)
      END SUBROUTINE BOUND
! -----------------------------------------------------------------------
! 
! MAP_UTIL_REED
!   To read a real number in a way which to some extent traps typing 
!   errors.
!
! -----------------------------------------------------------------------
      SUBROUTINE MAP_UTIL_REED(A)
      USE MAP_Util_Global_Data
      IMPLICIT NONE
!
! Argument
!
      REAL(KIND=real_8_30),INTENT(OUT) :: A
!
! Local Variables
!
      INTEGER :: ioerror

      DO
        READ(UNIT=5,IOSTAT=ioerror,FMT=*) A
        IF (ioerror .NE. 0) THEN
           WRITE(UNIT=6,FMT=1) 
        ELSE
           EXIT
        END IF
      END DO
   
    RETURN
1   FORMAT (19X,' Incorrect Input. Try again'/)
  END SUBROUTINE MAP_UTIL_REED
! -----------------------------------------------------------------------
!
! MAP_UTIL_REEDI
! To read integers in a way which to some extent traps typing errors
!
! -----------------------------------------------------------------------
      SUBROUTINE MAP_UTIL_REEDI(I)
      IMPLICIT NONE
!
! Argument
!
      INTEGER,INTENT(OUT) :: I

!
! Local Variables
!
      INTEGER :: ioerror

	  DO
        READ(UNIT=5,IOSTAT=ioerror,FMT=*) I
        IF (ioerror .NE. 0) THEN
           WRITE(UNIT=6,FMT=1) 
        ELSE
           EXIT
        END IF
	  END DO
   
    RETURN
1   FORMAT (19X,' Incorrect Input. Try again'/)
  END SUBROUTINE MAP_UTIL_REEDI
!-----------------------------------------------------------------------
!
! Subroutine REED_IN_FILE
!
!--------------------------------------------------------------------

  SUBROUTINE REED_IN_FILE(C,ITYPE)
    USE MAP_Util_Global_Data
    IMPLICIT NONE
!
! Arguments
!
    REAL(KIND=real_8_30), INTENT(INOUT) :: C
    INTEGER, INTENT(IN)  :: ITYPE
!
! Local Variables
!
      REAL(KIND=real_8_30) :: UPPER,LOWER

      CALL CHECK_ITYPE(ITYPE,UPPER,LOWER)
 
      READ(14,*) C

      IF (C .LT. LOWER .OR. C .GT. UPPER)	&
         CALL BOUND(C,LOWER,UPPER)

    RETURN
  END SUBROUTINE REED_IN_FILE
!-----------------------------------------------------------------------
!
! Subroutine REED_IN_KEYS
!
!-----------------------------------------------------------------------

SUBROUTINE REED_IN_KEYS(C,ITYPE)
  USE MAP_Util_Global_Data
  IMPLICIT NONE
!
! Arguments
!
  REAL(KIND=real_8_30), INTENT(INOUT) :: C
  INTEGER, INTENT(IN)  :: ITYPE
!
! Local Variables
!
  REAL(KIND=real_8_30) :: UPPER,LOWER

  CALL CHECK_ITYPE(ITYPE,UPPER,LOWER)

  CALL reed(C)

  IF (C .LT. LOWER .OR. C .GT. UPPER)	&
&   CALL BOUND(C,LOWER,UPPER)

  RETURN
  END SUBROUTINE REED_IN_KEYS
!-----------------------------------------------------------------------
!
!  Subroutine CHECK_ITYPE
!
!-----------------------------------------------------------------------
  SUBROUTINE CHECK_ITYPE(ITYPE,UPPER,LOWER)
    USE MAP_Util_Global_Data
    IMPLICIT NONE
!
! Arguments
!
    INTEGER,INTENT(IN)   :: ITYPE
    REAL(KIND=real_8_30),INTENT(OUT) :: UPPER,LOWER

  SELECT CASE (ITYPE)
    CASE (1)
      UPPER = 2.0E+00
      LOWER = 0.1E-03
      WRITE(UNIT=6,FMT=1050)
    CASE (2)
      UPPER = 2.5E+00
      LOWER = 0.0E+00
      WRITE(UNIT=6,FMT=1055)
    CASE (3)
      UPPER = 3.5E+00
      LOWER = 0.0E+00
      WRITE(UNIT=6,FMT=1060)
    CASE (4)
      UPPER = 4.5E+00
      LOWER = 0.0E+00
      WRITE(UNIT=6,FMT=1065)
    CASE (5)
      UPPER = 1.5E+00
      LOWER = 0.0E+00
      WRITE(UNIT=6,FMT=1070)
   CASE (6)
      UPPER = 3.5E+00
      LOWER = 0.0E+00
      WRITE(UNIT=6,FMT=1075)
   CASE (7)
      UPPER = 1.5E+00
      LOWER = 0.0E+00
      WRITE(UNIT=6,FMT=1080)
   END SELECT


    RETURN
1050  FORMAT(19X,' Carbon wt.% ?')
1055  FORMAT(19X,' Silicon wt.% ?')
1060  FORMAT(19X,' Manganese wt.% ?')
1065  FORMAT(19X,' Nickel wt.% ?')
1070  FORMAT(19X,' Molybdenum wt.% ?')
1075  FORMAT(19X,' Chromium wt.% ?')
1080  FORMAT(19X,' Vanadium wt.% ?')
  END SUBROUTINE CHECK_ITYPE
!-----------------------------------------------------------------------
!
!  Subroutine INPUT_TYPE
!
!-----------------------------------------------------------------------
  SUBROUTINE INPUT_TYPE(C)
    USE MAP_Util_Global_Data
    IMPLICIT NONE
!
! Arguments
!
    REAL(KIND=real_8_30),DIMENSION(8),INTENT(OUT) :: C
!
! Local Variables
!
    INTEGER :: I,II

      WRITE(6,1)
	  WRITE(6,2)
 
      CALL reed(I)

      DO
        IF (I .LT. 0 .OR. I .GT. 2) THEN
	       CALL reed(I)
        ELSE
	       EXIT
        END  IF
      END DO

      IF (I .EQ. 1) THEN
         DO II=1,7,1 
           CALL REED_IN_FILE(C(II),II)
         END DO
	  ELSE IF (I .EQ. 2) THEN
	     DO II=1,7,1
           CALL REED_IN_KEYS(C(II),II)
         END DO
      END IF

    RETURN
1   FORMAT(4X, 'Input data from file : 1')
2   FORMAT(4X, 'Input data from keyboard : 2')
  END SUBROUTINE INPUT_TYPE
!-----------------------------------------------------------------------

END MODULE MAP_Steel_Acquire_Data
